Index: /data/Media/materials/scripts/Flares.material
===================================================================
--- /data/Media/materials/scripts/Flares.material	(revision 5155)
+++ /data/Media/materials/scripts/Flares.material	(revision 5155)
@@ -0,0 +1,129 @@
+material Flares/point_lensflare
+{
+	technique
+	{
+		pass
+		{
+			lighting off
+			depth_write off
+			scene_blend add
+
+			point_sprites on
+			point_size 0.1
+			point_size_attenuation on
+
+			texture_unit
+			{
+				texture flare.tga
+			}
+		}
+	}
+}
+
+material Flares/lensflare
+{
+	technique
+	{
+		pass
+		{
+			lighting off
+			depth_write off
+			scene_blend add
+
+			texture_unit
+			{
+				texture flare.tga
+			}
+		}
+	}
+}
+
+material Flares/ringflare
+{
+	technique
+	{
+		pass
+		{
+			lighting off
+			depth_write off
+			scene_blend add
+
+			texture_unit
+			{
+				texture ring_flare.tga
+			}
+		}
+	}
+}
+
+material Flares/ringflare2
+{
+	technique
+	{
+		pass
+		{
+			lighting off
+			depth_write off
+			scene_blend add
+
+			texture_unit
+			{
+				texture ring_flare2.tga
+			}
+		}
+	}
+}
+
+material Flares/Flare
+{
+	technique
+	{
+		pass
+		{
+			lighting off
+			scene_blend add
+			depth_write off
+
+			texture_unit
+			{
+				texture flaretrail.tga
+			}
+		}
+	}
+}
+
+material Flares/backlightflare
+{
+	technique
+	{
+		pass
+		{
+			lighting off
+			scene_blend add
+			depth_write off
+
+			texture_unit
+			{
+				texture backlightflare.tga
+			}
+		}
+	}
+}
+
+material Flares/ThrusterFlare1
+{
+	technique
+	{
+		pass
+		{
+			lighting off
+			scene_blend add
+			depth_write off
+
+			texture_unit
+			{
+				texture bigflare1.tga
+			}
+		}
+	}
+}
Index: /data/Media/materials/scripts/PE_materials.material
===================================================================
--- /data/Media/materials/scripts/PE_materials.material	(revision 5154)
+++ /data/Media/materials/scripts/PE_materials.material	(revision 5155)
@@ -93,4 +93,22 @@
 }
 
+material PE/smoke3
+{
+	technique
+	{
+		pass
+		{
+			lighting off
+			depth_write off
+			scene_blend alpha_blend
+
+			texture_unit
+			{
+				texture smoke3.tga
+			}
+		}
+	}
+}
+
 material PE/explosion
 {
@@ -111,4 +129,22 @@
 }
 
+material PE/explosion3
+{
+	technique
+	{
+		pass
+		{
+			lighting off
+			depth_write off
+			scene_blend add
+
+			texture_unit
+			{
+				texture explosion3.tga
+			}
+		}
+	}
+}
+
 material PE/ringflare
 {
Index: /data/Media/particle/explosion3.particle
===================================================================
--- /data/Media/particle/explosion3.particle	(revision 5155)
+++ /data/Media/particle/explosion3.particle	(revision 5155)
@@ -0,0 +1,72 @@
+
+Orxonox/explosion3
+{
+	quota	10
+	material	PE/explosion3
+	particle_width	20
+	particle_height	20
+	cull_each	false
+	renderer	billboard
+	sorted	false
+	local_space	false
+	iteration_interval	0
+	nonvisible_update_timeout	0
+	billboard_type	point
+	billboard_origin	center
+	billboard_rotation_type	vertex
+	common_up_vector	0 1 0
+	point_rendering	false
+	accurate_facing	false
+
+	emitter Point
+	{
+		angle	180
+		colour	0 0 0 0
+		colour_range_start	0 0 0 0
+		colour_range_end	0 0 0 0
+		direction	0 1 0
+		emission_rate	40
+		position	0 0 0
+		velocity	0
+		velocity_min	0
+		velocity_max	0
+		time_to_live	0.5
+		time_to_live_min	0.5
+		time_to_live_max	0.5
+		duration	0.1
+		duration_min	0.1
+		duration_max	0.1
+		repeat_delay	2
+		repeat_delay_min	2
+		repeat_delay_max	2
+	}
+
+	affector Scaler
+	{
+		rate	100
+	}
+
+	affector Rotator
+	{
+		rotation_speed_range_start	0
+		rotation_speed_range_end	0
+		rotation_range_start	0
+		rotation_range_end	360
+	}
+
+	affector ColourInterpolator
+	{
+		colour0	0 0 0 0
+		time0	0
+		colour1	0.3 0.3 0.3 0
+		time1	0.1
+		colour2	0.2 0.2 0.2 0
+		time2	0.4
+		colour3	0 0 0 0
+		time3	1
+		colour4	0.5 0.5 0.5 0
+		time4	1
+		colour5	0.5 0.5 0.5 0
+		time5	1
+	}
+}
Index: /data/Media/particle/fire3.particle
===================================================================
--- /data/Media/particle/fire3.particle	(revision 5155)
+++ /data/Media/particle/fire3.particle	(revision 5155)
@@ -0,0 +1,72 @@
+
+Orxonox/fire3
+{
+	quota	50
+	material	PE/explosion3
+	particle_width	40
+	particle_height	40
+	cull_each	false
+	renderer	billboard
+	sorted	false
+	local_space	false
+	iteration_interval	0
+	nonvisible_update_timeout	0
+	billboard_type	point
+	billboard_origin	center
+	billboard_rotation_type	vertex
+	common_up_vector	0 1 0
+	point_rendering	false
+	accurate_facing	false
+
+	emitter Point
+	{
+		angle	180
+		colour	0 0 0 0
+		colour_range_start	0 0 0 0
+		colour_range_end	0 0 0 0
+		direction	0 1 0
+		emission_rate	50
+		position	0 0 0
+		velocity	0
+		velocity_min	0
+		velocity_max	0
+		time_to_live	1
+		time_to_live_min	1
+		time_to_live_max	1
+		duration	0
+		duration_min	0
+		duration_max	0
+		repeat_delay	0
+		repeat_delay_min	0
+		repeat_delay_max	0
+	}
+
+	affector Scaler
+	{
+		rate	40
+	}
+
+	affector Rotator
+	{
+		rotation_speed_range_start	0
+		rotation_speed_range_end	0
+		rotation_range_start	0
+		rotation_range_end	360
+	}
+
+	affector ColourInterpolator
+	{
+		colour0	0 0 0 0
+		time0	0
+		colour1	0.3 0.3 0.3 0
+		time1	0.1
+		colour2	0.2 0.2 0.2 0
+		time2	0.4
+		colour3	0 0 0 0
+		time3	1
+		colour4	0.5 0.5 0.5 0
+		time4	1
+		colour5	0.5 0.5 0.5 0
+		time5	1
+	}
+}
Index: /data/Media/particle/smoke4.particle
===================================================================
--- /data/Media/particle/smoke4.particle	(revision 5155)
+++ /data/Media/particle/smoke4.particle	(revision 5155)
@@ -0,0 +1,72 @@
+
+Orxonox/smoke4
+{
+	quota	10
+	material	PE/smoke3
+	particle_width	30
+	particle_height	30
+	cull_each	false
+	renderer	billboard
+	sorted	false
+	local_space	false
+	iteration_interval	0
+	nonvisible_update_timeout	0
+	billboard_type	point
+	billboard_origin	center
+	billboard_rotation_type	vertex
+	common_up_vector	0 1 0
+	point_rendering	false
+	accurate_facing	false
+
+	emitter Point
+	{
+		angle	180
+		colour	0 0 0 0
+		colour_range_start	0 0 0 0
+		colour_range_end	0 0 0 0
+		direction	0 1 0
+		emission_rate	15
+		position	0 0 0
+		velocity	20
+		velocity_min	20
+		velocity_max	20
+		time_to_live	1.5
+		time_to_live_min	1.5
+		time_to_live_max	1.5
+		duration	0.3
+		duration_min	0.3
+		duration_max	0.3
+		repeat_delay	1000000
+		repeat_delay_min	1000000
+		repeat_delay_max	1000000
+	}
+
+	affector Scaler
+	{
+		rate	60
+	}
+
+	affector Rotator
+	{
+		rotation_speed_range_start	-50
+		rotation_speed_range_end	50
+		rotation_range_start	0
+		rotation_range_end	0
+	}
+
+	affector ColourInterpolator
+	{
+		colour0	0 0 0 0
+		time0	0
+		colour1	0.5 0.5 0.5 0.4
+		time1	0.2
+		colour2	0.5 0.5 0.5 0.8
+		time2	0.5
+		colour3	0 0 0 0
+		time3	1
+		colour4	0.5 0.5 0.5 0
+		time4	1
+		colour5	0.5 0.5 0.5 0
+		time5	1
+	}
+}
Index: /data/Media/particle/smoke5.particle
===================================================================
--- /data/Media/particle/smoke5.particle	(revision 5155)
+++ /data/Media/particle/smoke5.particle	(revision 5155)
@@ -0,0 +1,72 @@
+
+Orxonox/smoke5
+{
+	quota	80
+	material	PE/smoke3
+	particle_width	40
+	particle_height	40
+	cull_each	false
+	renderer	billboard
+	sorted	false
+	local_space	false
+	iteration_interval	0
+	nonvisible_update_timeout	0
+	billboard_type	point
+	billboard_origin	center
+	billboard_rotation_type	vertex
+	common_up_vector	0 1 0
+	point_rendering	false
+	accurate_facing	false
+
+	emitter Point
+	{
+		angle	180
+		colour	0 0 0 0
+		colour_range_start	0 0 0 0
+		colour_range_end	0 0 0 0
+		direction	0 1 0
+		emission_rate	20
+		position	0 0 0
+		velocity	7
+		velocity_min	7
+		velocity_max	7
+		time_to_live	3
+		time_to_live_min	3
+		time_to_live_max	3
+		duration	0
+		duration_min	0
+		duration_max	0
+		repeat_delay	0
+		repeat_delay_min	0
+		repeat_delay_max	0
+	}
+
+	affector Scaler
+	{
+		rate	30
+	}
+
+	affector Rotator
+	{
+		rotation_speed_range_start	-50
+		rotation_speed_range_end	50
+		rotation_range_start	0
+		rotation_range_end	0
+	}
+
+	affector ColourInterpolator
+	{
+		colour0	0 0 0 0
+		time0	0
+		colour1	0.5 0.5 0.5 0.4
+		time1	0.05
+		colour2	0.3 0.3 0.3 0.8
+		time2	0.5
+		colour3	0.1 0.1 0.1 0.4
+		time3	0.8
+		colour4	0 0 0 0
+		time4	1
+		colour5	0.5 0.5 0.5 0
+		time5	1
+	}
+}
Index: /data/Media/particle/thruster2.particle
===================================================================
--- /data/Media/particle/thruster2.particle	(revision 5154)
+++ /data/Media/particle/thruster2.particle	(revision 5155)
@@ -1,8 +1,8 @@
 Orxonox/thruster2
 {
-	quota	200
+	quota	150
 	material	PE/bigFlame
-	particle_width	12
-	particle_height	12
+	particle_width	15
+	particle_height	15
 	cull_each	false
 	renderer	billboard
@@ -12,9 +12,9 @@
 	{
 		angle	0
-		colour	0.46875 0.8125 0.93359375 1
-		colour_range_start	.6640625 .91796875 .92578125 1
-		colour_range_end	.08203125 .7578125 .98046875 1
+		colour	0.4 0.3 0.8 1
+		colour_range_start	0.4 0.3 0.8 1
+		colour_range_end	0.5 0.4 0.9 1
 		direction	0 1 0
-		emission_rate	200
+		emission_rate	400
 		position	0 0 0
 		velocity	5
@@ -37,3 +37,11 @@
 		inner_depth	0.2
 	}
+
+	affector ColourFader
+	{
+		red	-0.5
+		green	-0.5
+		blue	-0.6
+		alpha	-0.5
+	}
 }