Index: /trunk/configure
===================================================================
--- /trunk/configure	(revision 5157)
+++ /trunk/configure	(revision 5158)
@@ -5518,5 +5518,5 @@
 
 CPPFLAGS="-I/usr/X11R6/include -I/usr/include"
-LDFLAGS="-L/usr/lib/opengl/xorg-x11/lib -L/usr/Mesa-6.0.1/lib -L/usr/X11R6/lib $LDFLAGS"
+##LDFLAGS="-L/usr/lib/opengl/xorg-x11/lib -L/usr/Mesa-6.0.1/lib -L/usr/X11R6/lib $LDFLAGS"
 # checking gl header
 
Index: /trunk/configure.ac
===================================================================
--- /trunk/configure.ac	(revision 5157)
+++ /trunk/configure.ac	(revision 5158)
@@ -347,5 +347,5 @@
 
 CPPFLAGS="-I/usr/X11R6/include -I/usr/include"
-LDFLAGS="-L/usr/lib/opengl/xorg-x11/lib -L/usr/Mesa-6.0.1/lib -L/usr/X11R6/lib $LDFLAGS"
+##LDFLAGS="-L/usr/lib/opengl/xorg-x11/lib -L/usr/Mesa-6.0.1/lib -L/usr/X11R6/lib $LDFLAGS"
 # checking gl header
    AC_CHECK_HEADERS([GL/gl.h] ,,
Index: /trunk/orxonox.kdevelop
===================================================================
--- /trunk/orxonox.kdevelop	(revision 5157)
+++ /trunk/orxonox.kdevelop	(revision 5158)
@@ -10,9 +10,9 @@
     <projectdirectory>.</projectdirectory>
     <absoluteprojectpath>false</absoluteprojectpath>
-    <description/>
+    <description></description>
     <secondaryLanguages>
       <language>C</language>
     </secondaryLanguages>
-    <versioncontrol/>
+    <versioncontrol>kdevsubversion</versioncontrol>
   </general>
   <kdevcustomproject>
@@ -21,5 +21,5 @@
       <directoryradio>build</directoryradio>
       <customdirectory>/</customdirectory>
-      <programargs/>
+      <programargs></programargs>
       <terminal>false</terminal>
       <autocompile>true</autocompile>
@@ -28,5 +28,5 @@
     <build>
       <buildtool>make</buildtool>
-      <builddir/>
+      <builddir></builddir>
     </build>
     <make>
@@ -35,21 +35,21 @@
       <prio>0</prio>
       <dontact>false</dontact>
-      <makebin/>
-      <makeoptions/>
+      <makebin></makebin>
+      <makeoptions></makeoptions>
       <selectedenvironment>default</selectedenvironment>
       <environments>
         <default/>
       </environments>
-      <defaulttarget/>
+      <defaulttarget></defaulttarget>
     </make>
   </kdevcustomproject>
   <kdevdebugger>
     <general>
-      <dbgshell/>
-      <programargs/>
-      <gdbpath/>
-      <configGdbScript/>
-      <runShellScript/>
-      <runGdbScript/>
+      <dbgshell></dbgshell>
+      <programargs></programargs>
+      <gdbpath></gdbpath>
+      <configGdbScript></configGdbScript>
+      <runShellScript></runShellScript>
+      <runGdbScript></runGdbScript>
       <breakonloadinglibs>true</breakonloadinglibs>
       <separatetty>false</separatetty>
@@ -131,5 +131,5 @@
     </codecompletion>
     <creategettersetter>
-      <prefixGet/>
+      <prefixGet></prefixGet>
       <prefixSet>set</prefixSet>
       <prefixVariable>m_,_</prefixVariable>
@@ -140,8 +140,5 @@
   </kdevcppsupport>
   <kdevfileview>
-    <groups>
-      <hidenonprojectfiles>false</hidenonprojectfiles>
-      <hidenonlocation>false</hidenonlocation>
-    </groups>
+    <groups/>
     <tree>
       <hidepatterns>*.o,*.lo,*~,*in</hidepatterns>
@@ -157,12 +154,12 @@
   <kdevdocumentation>
     <projectdoc>
-      <docsystem/>
-      <docurl/>
-      <usermanualurl/>
+      <docsystem></docsystem>
+      <docurl></docurl>
+      <usermanualurl></usermanualurl>
     </projectdoc>
   </kdevdocumentation>
   <ctagspart>
-    <customArguments/>
-    <customTagfilePath/>
+    <customArguments></customArguments>
+    <customTagfilePath></customTagfilePath>
   </ctagspart>
 </kdevelop>
Index: /trunk/src/orxonox.cc
===================================================================
--- /trunk/src/orxonox.cc	(revision 5157)
+++ /trunk/src/orxonox.cc	(revision 5158)
@@ -21,5 +21,5 @@
    ### File Specific:
    main-programmer: Patrick Boenzli
-   co-programmer: Christian Meyer
+co-programmer: Christian Meyer
    co-programmer: Benjamin Grauer: injected ResourceManager/GraphicsEngine/GUI
 */
@@ -31,5 +31,5 @@
 #include "world.h"
 #include "ini_parser.h"
-#include "game_loader.h"
+#include "game_loader.h"		
 
 //ENGINES
Index: /trunk/src/util/shell.cc
===================================================================
--- /trunk/src/util/shell.cc	(revision 5157)
+++ /trunk/src/util/shell.cc	(revision 5158)
@@ -56,5 +56,5 @@
   //this->bufferSize = 0;
   this->bufferText = NULL;
-  this->setBufferSize(100);
+  this->setBufferSize(10);
   this->bufferDisplaySize = 10;
   this->setAbsCoor2D(3, -400);
@@ -184,4 +184,5 @@
     this->bufferText[i]->setText(this->bufferIterator->prevElement(), false);
 }
+
 
 /**
@@ -632,18 +633,18 @@
   glBlendFunc(GL_SRC_ALPHA, GL_ONE);
 
-//  glBindTexture(GL_TEXTURE_2D, this->texture);
-  glBegin(GL_QUADS);
-
-//  glTexCoord2f(this->texCoord.minU, this->texCoord.minV);
+  glBindTexture(GL_TEXTURE_2D, 0);
+  glBegin(GL_TRIANGLE_STRIP);
+
+  glTexCoord2f(0, 0);
   glVertex2f(this->getAbsCoor2D().x,   this->getAbsCoor2D().y  );
 
-//  glTexCoord2f(this->texCoord.maxU, this->texCoord.minV);
+  glTexCoord2f(1, 0);
   glVertex2f(GraphicsEngine::getInstance()->getResolutionX() - this->getAbsCoor2D().x, this->getAbsCoor2D().y  );
 
-//  glTexCoord2f(this->texCoord.maxU, this->texCoord.maxV);
+  glTexCoord2f(0, 1);
+  glVertex2f(this->getAbsCoor2D().x, this->getAbsCoor2D().y + this->shellHeight);
+
+  glTexCoord2f(1, 1);
   glVertex2f(GraphicsEngine::getInstance()->getResolutionX() - this->getAbsCoor2D().x, this->getAbsCoor2D().y + this->shellHeight);
-
-//  glTexCoord2f(this->texCoord.minU, this->texCoord.maxV);
-  glVertex2f(this->getAbsCoor2D().x, this->getAbsCoor2D().y + this->shellHeight);
 
   glEnd();