Index: /data/Media/fonts/LiberationMono.fontdef
===================================================================
--- /data/Media/fonts/LiberationMono.fontdef	(revision 5158)
+++ /data/Media/fonts/LiberationMono.fontdef	(revision 5159)
@@ -3,5 +3,5 @@
 	type 		truetype
 	source 	LiberationMono.ttf
-	size 		18
+	size 		32
 	resolution 	96
 	code_points 33-126 161-255 
Index: /data/Media/fonts/MonoSpatial.fontdef
===================================================================
--- /data/Media/fonts/MonoSpatial.fontdef	(revision 5158)
+++ /data/Media/fonts/MonoSpatial.fontdef	(revision 5159)
@@ -3,5 +3,5 @@
 	type 		truetype
 	source 	MonoSpatial.ttf
-	size 		18
+	size 		32
 	resolution 	96
 	code_points 33-126 161-255 
Index: /data/Media/fonts/Monofur.fontdef
===================================================================
--- /data/Media/fonts/Monofur.fontdef	(revision 5158)
+++ /data/Media/fonts/Monofur.fontdef	(revision 5159)
@@ -3,5 +3,5 @@
 	type 		truetype
 	source 	Monofur.ttf
-	size 		18
+	size 		32
 	resolution 	96
 	code_points 33-126 161-255 
Index: /data/Media/fonts/SaxMono.fontdef
===================================================================
--- /data/Media/fonts/SaxMono.fontdef	(revision 5158)
+++ /data/Media/fonts/SaxMono.fontdef	(revision 5159)
@@ -3,5 +3,5 @@
 	type 		truetype
 	source 	SaxMono.ttf
-	size 		18
+	size 		32
 	resolution 	96
 	code_points 33-126 161-255 
Index: /data/Media/fonts/Selectric.fontdef
===================================================================
--- /data/Media/fonts/Selectric.fontdef	(revision 5158)
+++ /data/Media/fonts/Selectric.fontdef	(revision 5159)
@@ -3,5 +3,5 @@
 	type 		truetype
 	source 	Selectric.ttf
-	size 		18
+	size 		32
 	resolution 	96
 	code_points 33-126 161-255 
Index: /data/Media/fonts/ShareTechMono.fontdef
===================================================================
--- /data/Media/fonts/ShareTechMono.fontdef	(revision 5158)
+++ /data/Media/fonts/ShareTechMono.fontdef	(revision 5159)
@@ -3,5 +3,5 @@
 	type 		truetype
 	source 	ShareTechMono.ttf
-	size 		18
+	size 		32
 	resolution 	96
 	code_points 33-126 161-255 
Index: /data/Media/fonts/Tt-Kp.fontdef
===================================================================
--- /data/Media/fonts/Tt-Kp.fontdef	(revision 5158)
+++ /data/Media/fonts/Tt-Kp.fontdef	(revision 5159)
@@ -3,5 +3,5 @@
 	type 		truetype
 	source 	Tt-Kp.ttf
-	size 		18
+	size 		32
 	resolution 	96
 	code_points 33-126 161-255 
Index: /data/Media/fonts/VeraMono.fontdef
===================================================================
--- /data/Media/fonts/VeraMono.fontdef	(revision 5158)
+++ /data/Media/fonts/VeraMono.fontdef	(revision 5159)
@@ -3,5 +3,5 @@
 	type 		truetype
 	source 	VeraMono.ttf
-	size 		18
+	size 		32
 	resolution 	96
 	code_points 33-126 161-255 
Index: /data/Media/fonts/console.fontdef
===================================================================
--- /data/Media/fonts/console.fontdef	(revision 5158)
+++ /data/Media/fonts/console.fontdef	(revision 5159)
@@ -3,5 +3,5 @@
 	type 		truetype
 	source 	typewriter.ttf
-	size 		18
+	size 		32
 	resolution 	96
 	code_points 33-126 161-255 
Index: /data/Media/fonts/sample.fontdef
===================================================================
--- /data/Media/fonts/sample.fontdef	(revision 5158)
+++ /data/Media/fonts/sample.fontdef	(revision 5159)
@@ -5,5 +5,5 @@
 	type 		truetype
 	source 		solo5.ttf
-	size 		16
+	size 		32
 	resolution 	96
 }
Index: /data/Media/overlay/hud.oxo
===================================================================
--- /data/Media/overlay/hud.oxo	(revision 5158)
+++ /data/Media/overlay/hud.oxo	(revision 5159)
@@ -10,7 +10,7 @@
    value      = 0
   >
-    <BarColour position=0.7 colour=0.2,0.7,0.2/>
-    <BarColour position=0.4 colour=0.7,0.5,0.2/>
-    <BarColour position=0.1 colour=0.7,0.2,0.2/>
+    <BarColour position = 0.7 colour = "0.2,0.7,0.2" />
+    <BarColour position = 0.4 colour = "0.7,0.5,0.2" />
+    <BarColour position = 0.1 colour = "0.7,0.2,0.2" />
   </HUDSpeedBar>
 
@@ -24,7 +24,7 @@
    right2left = true
   >
-    <BarColour position=0.7 colour=0.2,0.7,0.2/>
-    <BarColour position=0.4 colour=0.7,0.5,0.2/>
-    <BarColour position=0.1 colour=0.7,0.2,0.2/>
+    <BarColour position = 0.7 colour = "0.2,0.7,0.2" />
+    <BarColour position = 0.4 colour = "0.7,0.5,0.2" />
+    <BarColour position = 0.1 colour = "0.7,0.2,0.2" />
   </HUDSpeedBar>
 
@@ -38,7 +38,7 @@
    right2left = true
   >
-    <BarColour position=0.7 colour=0.2,0.7,0.2/>
-    <BarColour position=0.4 colour=0.7,0.5,0.2/>
-    <BarColour position=0.1 colour=0.7,0.2,0.2/>
+    <BarColour position = 0.7 colour = "0.2,0.7,0.2" />
+    <BarColour position = 0.4 colour = "0.7,0.5,0.2" />
+    <BarColour position = 0.1 colour = "0.7,0.2,0.2" />
   </HUDSpeedBar>
 
@@ -49,9 +49,10 @@
    position   = "0.0 , 0.0 "
    origin     = "0, 0"
+   rotation   = 0
    value      = 0
   >
-    <BarColour position=0.7 colour=0.2,0.7,0.2/>
-    <BarColour position=0.4 colour=0.7,0.5,0.2/>
-    <BarColour position=0.1 colour=0.7,0.2,0.2/>
+    <BarColour position = 0.7 colour = "0.2,0.7,0.2" />
+    <BarColour position = 0.4 colour = "0.7,0.5,0.2" />
+    <BarColour position = 0.1 colour = "0.7,0.2,0.2" />
   </HUDSpeedBar>
 
@@ -60,5 +61,7 @@
    correctAspect = true
    font          = "Monofur"
-   navmarkersize = "0.03, 0.03"
+   textSize      = 0.05
+   navMarkerSize = 0.03
+   aimMarkerSize = 0.04
   />
 
@@ -70,4 +73,8 @@
    position      = "0.5, 1.0"
    origin        = "0.5, 1.0"
+   rotation      = 0
+   sensitivity   = 1.0
+   halfDotSizeDistance = 3000
+   maximumDotSize      = 0.1
   />
 
@@ -76,20 +83,20 @@
 
 <!-- DEBUG OVERLAY -->
-<OverlayGroup name="Debug" scale=1,1>
+<OverlayGroup name = "Debug" scale = "1.0, 1.0" scroll = "0, 0">
 
   <DebugFPSText
    name     = "FPSText"
-   textSize = "0.03"
    position = "0.03, 0.05"
    font     = "Monofur"
    caption  = "Frames per second: "
+   textSize = 0.03
   />
 
   <DebugRTRText
    name     = "RTRText"
-   textSize = "0.03"
    position = "0.03, 0.09"
    font     = "Monofur"
-   caption  = "Render time ratio: "
+   caption  = "Tick time in ms: "
+   textSize = 0.03
   />
 