Index: trunk/src/lib/shell/Makefile.in
===================================================================
--- trunk/src/lib/particles/Makefile.in	(revision 5100)
+++ trunk/src/lib/shell/Makefile.in	(revision 5160)
@@ -16,5 +16,5 @@
 
 
-SOURCES = $(libORXparticles_a_SOURCES)
+SOURCES = $(libORXshell_a_SOURCES)
 
 srcdir = @srcdir@
@@ -39,5 +39,5 @@
 POST_UNINSTALL = :
 host_triplet = @host@
-subdir = src/lib/particles
+subdir = src/lib/shell
 DIST_COMMON = $(noinst_HEADERS) $(srcdir)/Makefile.am \
 	$(srcdir)/Makefile.in
@@ -52,17 +52,13 @@
 AR = ar
 ARFLAGS = cru
-libORXparticles_a_AR = $(AR) $(ARFLAGS)
-libORXparticles_a_LIBADD =
-am_libORXparticles_a_OBJECTS = particle_engine.$(OBJEXT) \
-	particle_emitter.$(OBJEXT) particle_system.$(OBJEXT) \
-	quick_animation.$(OBJEXT)
-libORXparticles_a_OBJECTS = $(am_libORXparticles_a_OBJECTS)
+libORXshell_a_AR = $(AR) $(ARFLAGS)
+libORXshell_a_LIBADD =
+am_libORXshell_a_OBJECTS = shell.$(OBJEXT) shell_command.$(OBJEXT)
+libORXshell_a_OBJECTS = $(am_libORXshell_a_OBJECTS)
 DEFAULT_INCLUDES = -I. -I$(srcdir) -I$(top_builddir)
 depcomp = $(SHELL) $(top_srcdir)/depcomp
 am__depfiles_maybe = depfiles
-@AMDEP_TRUE@DEP_FILES = ./$(DEPDIR)/particle_emitter.Po \
-@AMDEP_TRUE@	./$(DEPDIR)/particle_engine.Po \
-@AMDEP_TRUE@	./$(DEPDIR)/particle_system.Po \
-@AMDEP_TRUE@	./$(DEPDIR)/quick_animation.Po
+@AMDEP_TRUE@DEP_FILES = ./$(DEPDIR)/shell.Po \
+@AMDEP_TRUE@	./$(DEPDIR)/shell_command.Po
 CXXCOMPILE = $(CXX) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) \
 	$(AM_CPPFLAGS) $(CPPFLAGS) $(AM_CXXFLAGS) $(CXXFLAGS)
@@ -70,6 +66,6 @@
 CXXLINK = $(CXXLD) $(AM_CXXFLAGS) $(CXXFLAGS) $(AM_LDFLAGS) $(LDFLAGS) \
 	-o $@
-SOURCES = $(libORXparticles_a_SOURCES)
-DIST_SOURCES = $(libORXparticles_a_SOURCES)
+SOURCES = $(libORXshell_a_SOURCES)
+DIST_SOURCES = $(libORXshell_a_SOURCES)
 HEADERS = $(noinst_HEADERS)
 ETAGS = etags
@@ -185,14 +181,10 @@
 target_vendor = @target_vendor@
 MAINSRCDIR = ../..
-noinst_LIBRARIES = libORXparticles.a
-libORXparticles_a_SOURCES = particle_engine.cc \
-                            particle_emitter.cc \
-                            particle_system.cc \
-                            quick_animation.cc
-
-noinst_HEADERS = particle_engine.h \
-                particle_emitter.h \
-                particle_system.h \
-                quick_animation.h
+noinst_LIBRARIES = libORXshell.a
+libORXshell_a_SOURCES = shell.cc \
+		        shell_command.cc
+
+noinst_HEADERS = shell.h \
+                shell_command.h
 
 all: all-am
@@ -209,7 +201,7 @@
 	  esac; \
 	done; \
-	echo ' cd $(top_srcdir) && $(AUTOMAKE) --gnu  src/lib/particles/Makefile'; \
+	echo ' cd $(top_srcdir) && $(AUTOMAKE) --foreign  src/lib/shell/Makefile'; \
 	cd $(top_srcdir) && \
-	  $(AUTOMAKE) --gnu  src/lib/particles/Makefile
+	  $(AUTOMAKE) --foreign  src/lib/shell/Makefile
 .PRECIOUS: Makefile
 Makefile: $(srcdir)/Makefile.in $(top_builddir)/config.status
@@ -232,8 +224,8 @@
 clean-noinstLIBRARIES:
 	-test -z "$(noinst_LIBRARIES)" || rm -f $(noinst_LIBRARIES)
-libORXparticles.a: $(libORXparticles_a_OBJECTS) $(libORXparticles_a_DEPENDENCIES) 
-	-rm -f libORXparticles.a
-	$(libORXparticles_a_AR) libORXparticles.a $(libORXparticles_a_OBJECTS) $(libORXparticles_a_LIBADD)
-	$(RANLIB) libORXparticles.a
+libORXshell.a: $(libORXshell_a_OBJECTS) $(libORXshell_a_DEPENDENCIES) 
+	-rm -f libORXshell.a
+	$(libORXshell_a_AR) libORXshell.a $(libORXshell_a_OBJECTS) $(libORXshell_a_LIBADD)
+	$(RANLIB) libORXshell.a
 
 mostlyclean-compile:
@@ -243,8 +235,6 @@
 	-rm -f *.tab.c
 
-@AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/particle_emitter.Po@am__quote@
-@AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/particle_engine.Po@am__quote@
-@AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/particle_system.Po@am__quote@
-@AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/quick_animation.Po@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/shell.Po@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/shell_command.Po@am__quote@
 
 .cc.o: